> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create volume

> Create a new volume in the project and region.
The volume can be created from scratch, from an image, or from a snapshot.
Optionally attach the volume to an instance during creation.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml post /cloud/v1/volumes/{project_id}/{region_id}
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-11T15:10:30.328297+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/volumes/{project_id}/{region_id}:
    post:
      tags:
        - Volumes
      summary: Create volume
      description: >-
        Create a new volume in the project and region.

        The volume can be created from scratch, from an image, or from a
        snapshot.

        Optionally attach the volume to an instance during creation.
      operationId: VolumeViewSet.post
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 1
            examples:
              - 1
            title: Region Id
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateVolumeSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskIDsSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            task_id_list = client.cloud.volumes.create(
                project_id=1,
                region_id=1,
                image_id="169942e0-9b53-42df-95ef-1a8b6525c2bd",
                name="volume-1",
                size=10,
                source="image",
            )
            print(task_id_list.tasks)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\ttaskIDList, err := client.Cloud.Volumes.New(context.TODO(), cloud.VolumeNewParams{\n\t\tProjectID: gcore.Int(1),\n\t\tRegionID:  gcore.Int(1),\n\t\tOfImage: &cloud.VolumeNewParamsBodyImage{\n\t\t\tImageID: \"169942e0-9b53-42df-95ef-1a8b6525c2bd\",\n\t\t\tName:    \"volume-1\",\n\t\t\tSize:    10,\n\t\t},\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", taskIDList.Tasks)\n}\n"
components:
  schemas:
    CreateVolumeSerializer:
      description: Volume can be created from image, snapshot or as a new volume
      discriminator:
        mapping:
          image:
            $ref: '#/components/schemas/CreateVolumeFromImageSerializer'
          new-volume:
            $ref: '#/components/schemas/CreateNewVolumeSerializer'
          snapshot:
            $ref: '#/components/schemas/CreateVolumeFromSnapshotSerializer'
        propertyName: source
      oneOf:
        - $ref: '#/components/schemas/CreateVolumeFromImageSerializer'
        - $ref: '#/components/schemas/CreateVolumeFromSnapshotSerializer'
        - $ref: '#/components/schemas/CreateNewVolumeSerializer'
      title: CreateVolumeSerializer
    TaskIDsSerializer:
      properties:
        tasks:
          description: >-
            List of task IDs representing asynchronous operations. Use these IDs
            to monitor operation progress:

            - `GET /v1/tasks/{task_id}` - Check individual task status and
            details

            Poll task status until completion (`FINISHED`/`ERROR`) before
            proceeding with dependent operations.
          example:
            - d478ae29-dedc-4869-82f0-96104425f565
          examples:
            - - d478ae29-dedc-4869-82f0-96104425f565
          items:
            type: string
          title: Tasks
          type: array
      required:
        - tasks
      title: TaskIDsSerializer
      type: object
    CreateVolumeFromImageSerializer:
      properties:
        attachment_tag:
          description: >-
            Block device attachment tag (not exposed in the user tags). Only
            used in conjunction with `instance_id_to_attach_to`
          example: device-tag
          examples:
            - device-tag
          pattern: ^[^,/]{1,60}$
          title: Attachment Tag
          type: string
        image_id:
          description: Image ID
          example: 169942e0-9b53-42df-95ef-1a8b6525c2bd
          examples:
            - 169942e0-9b53-42df-95ef-1a8b6525c2bd
          format: uuid4
          title: Image Id
          type: string
        instance_id_to_attach_to:
          description: '`instance_id` to attach newly-created volume to'
          example: 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          examples:
            - 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          title: Instance Id To Attach To
          type: string
        lifecycle_policy_ids:
          description: >-
            List of lifecycle policy IDs (snapshot creation schedules) to
            associate with the volume
          example:
            - 1
            - 2
          examples:
            - - 1
              - 2
          items:
            type: integer
          title: Lifecycle Policy Ids
          type: array
        name:
          description: Volume name
          example: volume-1
          examples:
            - volume-1
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        size:
          description: Volume size in GiB
          example: 10
          examples:
            - 10
          minimum: 1
          title: Size
          type: integer
        source:
          const: image
          description: Volume source type
          example: image
          examples:
            - image
          title: Source
          type: string
        tags:
          $ref: '#/components/schemas/CreateTagsSerializer'
          description: >-
            Key-value tags to associate with the resource. A tag is a key-value
            pair that can be associated with a resource, enabling efficient
            filtering and grouping for better organization and management. Both
            tag keys and values have a maximum length of 255 characters. Some
            tags are read-only and cannot be modified by the user. Tags are also
            integrated with cost reports, allowing cost data to be filtered
            based on tag keys or values.
          examples:
            - my-tag: my-tag-value
        type_name:
          $ref: '#/components/schemas/VolumeTypeName'
          description: >-
            Volume type. Defaults to `standard`. If not specified for source
            `snapshot`, volume type will be derived from the snapshot volume.
          examples:
            - standard
      required:
        - name
        - source
        - image_id
        - size
      title: CreateVolumeFromImageSerializer
      type: object
    CreateNewVolumeSerializer:
      properties:
        attachment_tag:
          description: >-
            Block device attachment tag (not exposed in the user tags). Only
            used in conjunction with `instance_id_to_attach_to`
          example: device-tag
          examples:
            - device-tag
          pattern: ^[^,/]{1,60}$
          title: Attachment Tag
          type: string
        instance_id_to_attach_to:
          description: '`instance_id` to attach newly-created volume to'
          example: 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          examples:
            - 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          title: Instance Id To Attach To
          type: string
        lifecycle_policy_ids:
          description: >-
            List of lifecycle policy IDs (snapshot creation schedules) to
            associate with the volume
          example:
            - 1
            - 2
          examples:
            - - 1
              - 2
          items:
            type: integer
          title: Lifecycle Policy Ids
          type: array
        name:
          description: Volume name
          example: volume-1
          examples:
            - volume-1
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        size:
          description: Volume size in GiB
          example: 10
          examples:
            - 10
          minimum: 1
          title: Size
          type: integer
        source:
          const: new-volume
          description: Volume source type
          example: new-volume
          examples:
            - new-volume
          title: Source
          type: string
        tags:
          $ref: '#/components/schemas/CreateTagsSerializer'
          description: >-
            Key-value tags to associate with the resource. A tag is a key-value
            pair that can be associated with a resource, enabling efficient
            filtering and grouping for better organization and management. Both
            tag keys and values have a maximum length of 255 characters. Some
            tags are read-only and cannot be modified by the user. Tags are also
            integrated with cost reports, allowing cost data to be filtered
            based on tag keys or values.
          examples:
            - my-tag: my-tag-value
          x-stainless-terraform-configurability: computed_optional
        type_name:
          $ref: '#/components/schemas/VolumeTypeName'
          description: >-
            Volume type. Defaults to `standard`. If not specified for source
            `snapshot`, volume type will be derived from the snapshot volume.
          examples:
            - standard
      required:
        - name
        - source
        - size
      title: CreateNewVolumeSerializer
      type: object
    CreateVolumeFromSnapshotSerializer:
      properties:
        attachment_tag:
          description: >-
            Block device attachment tag (not exposed in the user tags). Only
            used in conjunction with `instance_id_to_attach_to`
          example: device-tag
          examples:
            - device-tag
          pattern: ^[^,/]{1,60}$
          title: Attachment Tag
          type: string
        instance_id_to_attach_to:
          description: '`instance_id` to attach newly-created volume to'
          example: 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          examples:
            - 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          title: Instance Id To Attach To
          type: string
        lifecycle_policy_ids:
          description: >-
            List of lifecycle policy IDs (snapshot creation schedules) to
            associate with the volume
          example:
            - 1
            - 2
          examples:
            - - 1
              - 2
          items:
            type: integer
          title: Lifecycle Policy Ids
          type: array
        name:
          description: Volume name
          example: volume-1
          examples:
            - volume-1
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        size:
          description: >-
            Volume size in GiB. If specified, value must be equal to respective
            snapshot size
          example: 10
          examples:
            - 10
          minimum: 1
          title: Size
          type: integer
        snapshot_id:
          description: Snapshot ID
          example: 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          examples:
            - 88f3e0bd-ca86-4cf7-be8b-dd2988e23c2d
          format: uuid4
          title: Snapshot Id
          type: string
        source:
          const: snapshot
          description: Volume source type
          example: snapshot
          examples:
            - snapshot
          title: Source
          type: string
        tags:
          $ref: '#/components/schemas/CreateTagsSerializer'
          description: >-
            Key-value tags to associate with the resource. A tag is a key-value
            pair that can be associated with a resource, enabling efficient
            filtering and grouping for better organization and management. Both
            tag keys and values have a maximum length of 255 characters. Some
            tags are read-only and cannot be modified by the user. Tags are also
            integrated with cost reports, allowing cost data to be filtered
            based on tag keys or values.
          examples:
            - my-tag: my-tag-value
        type_name:
          $ref: '#/components/schemas/VolumeTypeName'
          description: >-
            Volume type. Defaults to `standard`. If not specified for source
            `snapshot`, volume type will be derived from the snapshot volume.
          examples:
            - standard
      required:
        - name
        - source
        - snapshot_id
      title: CreateVolumeFromSnapshotSerializer
      type: object
    CreateTagsSerializer:
      description: >-
        A tag is a key-value pair that can be associated with a resource,

        enabling efficient filtering and grouping for better organization and
        management.

        Some tags are read-only and cannot be modified by the user.

        Tags are also integrated with cost reports, allowing cost data to be
        filtered based on tag keys or values.
      patternProperties:
        ^[^\s=]+$:
          description: >-
            Tag value. Maximum 255 characters. Cannot contain tabs, newlines,
            empty string or start/end with whitespace.
          example: my-tag-value
          examples:
            - my-tag-value
          maxLength: 255
          minLength: 1
          pattern: ^[^ \t\n\r\f\v]([^\t\n\r\f\v]*[^ \t\n\r\f\v])?$
          type: string
      propertyNames:
        description: >-
          Tag key. Maximum 255 characters. Cannot contain spaces, tabs,
          newlines, empty string or '=' character.
        examples:
          - my-tag
        maxLength: 255
        minLength: 1
      title: CreateTagsSerializer
      type: object
    VolumeTypeName:
      enum:
        - cold
        - ssd_hiiops
        - ssd_local
        - ssd_lowlatency
        - standard
        - ultra
      title: VolumeTypeName
      type: string
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````